;-----------------------------------------------------
;
;			Cherche un fichier dans la VAT
;				Entree : a5=nom du fichier
;				Sortie : a0=debut du fichier
;
;-----------------------------------------------------

ChercheFichier:
	movem.l		d1-d7/a1-a6,-(a7)

	move.l		(a5)+,d3
	move.l		(a5),d4

	move.w		FolderListHandle,-(a7)
	CALL		HeapDeref
	addq.l		#2,a7
	lea		2(a0),a6
	move.w		(a6),d7					; nombre de folders
	subq.w		#1,d7
	BoucleFolder:
		lea		14(a6),a6			; passe au prochain folder
		move.w		(a6),-(a7)
		CALL		HeapDeref
		addq.l		#2,a7
		addq.l		#2,a0
		move.w		(a0)+,d6
		beq		FolderVide
		subq.w		#1,d6
		BoucleFichier:
			cmp.l		(a0),d3
			bne		Suivant
			cmp.l		4(a0),d4
			bne		Suivant

			tst.w		d0
			beq		Suivant

			move.l		a0,a5
			move.w		12(a0),-(a7)
			CALL		HeapDeref
			addq.l		#2,a7

			bra		FichierTrouve

		Suivant:
			lea		14(a0),a0
			dbra		d6,BoucleFichier
	FolderVide:
		dbra		d7,BoucleFolder

	clr.l		d0
FichierTrouve:
	movem.l		(a7)+,d1-d7/a1-a6
	rts




ChercheFichierDansRep:
	movem.l		d1-d7/a1-a6,-(a7)
	move.l		a0,-(a7)			; Entre l'adresse du nom du fichier
	CALL		SymFind				; On va chercher le Handle, stock dans d0
	lea		4(a7),a7			; Restaure la pile

	tst.w		d0
	beq		FichierDansRepNonTrouve

	move.l		d0,-(a7)
	CALL		DerefSym
	add		#4,a7
	move.w		12(a0),d0

	move.w		d0,-(a7)
	CALL		HeapUnlock
	lea		2(a7),a7
FichierDansRepNonTrouve:
	movem.l		(a7)+,d1-d7/a1-a6
	rts
	
	
	
	
;-----------------------------------------------------
;
;			On pointe sur le fichier selectionne
;
;			--> renvoie l'adresse du fichier dans a0
;
;-----------------------------------------------------

PointeSurFichier:
	bsr		PointeSurLeHandleDuFichier
	move.w		12(a0),-(a7)			; Et on pointe dessus
	CALL		HeapDeref
	addq.l		#2,a7
	rts

PointeSurLeHandleDuFichier:
	bsr		PointeSurLeHandleDuDossier
	move.w		14(a0),-(a7)			; On pointe sur le bon dossier
	CALL		HeapDeref
	addq.l		#2,a7
	lea		4(a0),a0
	move.w		PositionBarre,d0		; Dans le dossier, on se dirige sur le fichier selectionne
	add.w		PositionListeEcran,d0
	mulu.w		#14,d0
	add.w		d0,a0
	rts


PointeSurLeHandleDuDossier:
	move.w		FolderListHandle,-(a7)
	CALL		HeapDeref
	addq.l		#2,a7
	lea		2(a0),a0			; On pointe sur la liste des dossiers
	move.w		RepertoireSelectionne,d0	; En fonction de la selection, on se dirige vers un des dossiers
	mulu.w		#14,d0
	add.w		d0,a0
	rts


RecupTailleRepCourant:
	movem.l		d1-d7/a0-a6,-(a7)
	bra		RepSelectionneRecupTaille
RecupereTailleRepertoire:
	movem.l		d1-d7/a0-a6,-(a7)
	move.w		FolderListHandle,-(a7)		; on recupere la taille du rep
	CALL		HeapDeref
	addq.l		#2,a7
	lea		2(a0),a0
	move.w		PositionBarre,d0
	add.w		PositionListeEcran,d0
	mulu.w		#14,d0
	add.w		d0,a0
RepSelectionneRecupTaille:
	move.w		14(a0),-(a7)
	CALL		HeapDeref
	addq.l		#2,a7
	lea		2(a0),a2			; pointe sur le bon rep
	clr.l		d4
	move.w		(a2)+,d7
	beq		RepertoireTailleVide			; si le dossier est vide, on n'affiche rien

	subq.w		#1,d7
	BoucleCalculTailleRep:
		move.w		12(a2),-(a7)			; affiche la taille du fichier
		CALL		HeapDeref
		addq.l		#2,a7
		clr.l		d6
		move.w		(a0),d6
		add.l		d6,d4
		add.l		#2,d4
		lea		14(a2),a2			; on passe au prochain fichier
		dbra		d7,BoucleCalculTailleRep
RepertoireTailleVide:
	move.l		d4,d0				; Taille dans d0.l
	movem.l		(a7)+,d1-d7/a0-a6
	rts
	
	
	


GetFreeArchive:
	movem.l		d1-d7/a0-a6,-(a7)

	sub.l		#12,a7			; Stack Frame
	move.l		a7,a2			; Get ptr to stack frame
	clr.l		-(a7)			; &allExceptBaseCode
	clr.l		-(a7)			; &badSectors
	pea		(a2)			; &unusedSectors
	pea		4(a2)			; &free
	pea		8(a2)			; &freeAfterGC
	clr.l		-(a7)			; &inUse

	CALL		EM_survey
	lea		8*4+4(a7),a7
	move.l		(a2)+,d0		; unusedSectors
	cmp.w		#'RO',$32
	bne		PasSousPedroM
	clr.l		d0
PasSousPedroM:
	add.l		(a2)+,d0		; free
	add.l		(a2)+,d0		; free+freeAfterGc
	movem.l		(a7)+,d1-d7/a0-a6
	rts
